<?php
add_filter('cmb_meta_boxes', 'stallion_aioseo_key4');
/**
 * Define the metabox and field configurations.
 *
 * @param  array $meta_boxes
 * @return array
 */
function stallion_aioseo_key4(array $meta_boxes) {
// Start with an underscore to hide fields from custom fields list
$prefix = '';
$meta_boxes[] = array(
'id' => 'stallion_aioseo_key4',
'title' => 'Social Media Open Graph Share Data',
'pages' => array('post', 'page'), // Post type
'context' => 'normal',
'priority' => 'high',
'show_names' => true, // Show field names on the left
'fields' => array(
array(
'name' => 'Open Graph Title',
'desc' => 'Add the title Facebook, Google+ etc... uses when sharing this post.',
'id' => $prefix . '_yoast_wpseo_opengraph-title',
'type' => 'text',
),
array(
'name' => 'Open Graph Description',
'desc' => 'Add a description Facebook, Google+ etc... uses when sharing this post.',
'id' => $prefix . '_yoast_wpseo_opengraph-description',
'type' => 'textarea_small',
),
array(
'name' => 'Open Graph Image',
'desc' => 'Upload/Select an image Facebook, Google+ etc... uses when sharing this post.',
'id' => $prefix . '_yoast_wpseo_opengraph-image',
'type' => 'file',
),

),
);
return $meta_boxes;
}

add_action('init', 'stallion_aioseo_key4_init', 9999);

/**
 * Initialize the metabox class.
 */
function stallion_aioseo_key4_init() {
if (!class_exists('cmb_Meta_Box'))
require_once 'init.php';
}
?>