<?php
if (st_reorderarchive_widget() == '1') {

$id_byreversealphabetical = "byreversealphabetical";
$id_byalphabetical = "byalphabetical";
$id_byoldest = "byoldest";
$id_bymodified = "bymodified";
$id_byrand = "byrand";
$id_bycomment_count = "bycomment_count";

function register_stsort_Widget() {
register_widget('stsort_Widget');
}

add_action('widgets_init', 'register_stsort_Widget');

function stsort_pre_get_posts($vars) {
$params = stsort_getOrderBySelect();
$vars->set('orderby', $params['orderby']);
$vars->set('order', $params['order']);
$vars->set('ignore_sticky_posts', 1);

return $vars;
}

add_filter('pre_get_posts', 'stsort_pre_get_posts');

function stsort_getOrderBySelect() {
$result = array();
$selection = isset($_GET['sort']) ? $_GET['sort'] : 'newest';

switch ($selection) {

case 'newest':
$result['orderby'] = "date";
$result['order'] = "DESC";

break;

case 'oldest':
$result['orderby'] = "date";
$result['order'] = "ASC";

break;

case 'alphabetical':
$result['orderby'] = "title";
$result['order'] = "ASC";

break;

case 'reversealphabetical':
$result['orderby'] = "title";
$result['order'] = "DESC";

break;

default:
$result['orderby'] = $selection;
$result['order'] = "DESC";

}

$result[$selection] = ' selected="selected"';
return $result;
}

add_filter('wp_head', 'stsort_getOrderBySelect');

class stsort_Widget extends WP_Widget {

/**
 * Register widget with WordPress.
 */
public function __construct() {
parent::__construct(
'stsort_widget', // Base ID
'Stallion Reorder Archived Content', // Name
array('description' => __('Adds a dropdown menu with up to 7 ways for visitors to order your content on archive parts of the site (home archives, categories etc...)', 'stallion'),) // Args
);
}

/**
 * Front-end display of widget.
 *
 * @see WP_Widget::widget()
 *
 * @param array $args     Widget arguments.
 * @param array $instance Saved values from database.
 */
public function widget($args, $instance) {
global $id_byreversealphabetical, $id_byalphabetical, $id_byoldest, $id_bymodified, $id_byrand, $id_bycomment_count;
if (!is_single() && !is_page()) {

$title = apply_filters('widget_title', $instance['title']);

echo $args['before_widget'];

if (!empty($title))
echo $args['before_title'] . $title . $args['after_title'];

$params = stsort_getOrderBySelect();

$opt_byoldest = $instance[$id_byoldest] ? "<option value=\"oldest\"{$params['oldest']}>" . __('Old to New', 'stallion') . "</option>" : "";
$opt_reversealphabetical = $instance[$id_byreversealphabetical] ? "<option value=\"reversealphabetical\"{$params['reversealphabetical']}>" . __('Z to A', 'stallion') . "</option>" : "";
$opt_alphabetical = $instance[$id_byalphabetical] ? "<option value=\"alphabetical\"{$params['alphabetical']}>" . __('A to Z', 'stallion') . "</option>" : "";
$opt_bymodified = $instance[$id_bymodified] ? "<option value=\"modified\"{$params['modified']}>" . __('Recently Modified', 'stallion') . "</option>" : "";
$opt_byrand = $instance[$id_byrand] ? "<option value=\"rand\"{$params['rand']}>" . __('Random Order', 'stallion') . "</option>" : "";
$opt_bycomment_count = $instance[$id_bycomment_count] ? "<option value=\"comment_count\"{$params['comment_count']}>" . __('Most Commented', 'stallion') . "</option>" : "";

/*
$opt_byoldest = $instance[$id_byoldest] ? "<option value=\"oldest\">" . __('Old to New', 'stallion') . "</option>" : "";
$opt_reversealphabetical = $instance[$id_byreversealphabetical] ? "<option value=\"reversealphabetical\">" . __('Z to A', 'stallion') . "</option>" : "";
$opt_alphabetical = $instance[$id_byalphabetical] ? "<option value=\"alphabetical\">" . __('A to Z', 'stallion') . "</option>" : "";
$opt_bymodified = $instance[$id_bymodified] ? "<option value=\"modified\">" . __('Recently Modified', 'stallion') . "</option>" : "";
$opt_byrand = $instance[$id_byrand] ? "<option value=\"rand\">" . __('Random Order', 'stallion') . "</option>" : "";
$opt_bycomment_count = $instance[$id_bycomment_count] ? "<option value=\"comment_count\">" . __('Most Commented', 'stallion') . "</option>" : "";*/

echo "<div class=\"loginfm\">
<form method=\"get\" id=\"order\">
<select name=\"sort\" onchange=\"this.form.submit()\">
<option value=\"comment_count\"{$params['comment_count']}>" . __('Most Commented', 'stallion') . "</option>
<option value=\"newest\"{$params['newest']}>" . __('New to Old', 'stallion') . "</option>
<option value=\"oldest\"{$params['oldest']}>" . __('Old to New', 'stallion') . "</option>
<option value=\"alphabetical\"{$params['alphabetical']}>" . __('A to Z', 'stallion') . "</option>
<option value=\"reversealphabetical\"{$params['reversealphabetical']}>" . __('Z to A', 'stallion') . "</option>
<option value=\"rand\"{$params['rand']}>" . __('Random Order', 'stallion') . "</option>
<option value=\"rand\"{$params['rand']}>" . __('Random Order', 'stallion') . "</option>
$opt_bycomment_count
$opt_byoldest
$opt_alphabetical
$opt_reversealphabetical
$opt_bymodified
$opt_byrand
</select>
</form></div>";

echo $args['after_widget'];
}
}

/**
 * Back-end widget form.
 *
 * @see WP_Widget::form()
 *
 * @param array $instance Previously saved values from database.
 */
public function form($instance) {
global $id_byreversealphabetical, $id_byalphabetical, $id_byoldest, $id_bymodified, $id_byrand, $id_bycomment_count;

$checked_byreversealphabetical = isset($instance[$id_byreversealphabetical]) ? 'checked="checked"' : '';
$checked_byalphabetical = isset($instance[$id_byalphabetical]) ? 'checked="checked"' : '';
$checked_byoldest = isset($instance[$id_byoldest]) ? 'checked="checked"' : '';
$checked_bymodified = isset($instance[$id_bymodified]) ? 'checked="checked"' : '';
$checked_byrand = isset($instance[$id_byrand]) ? 'checked="checked"' : '';
$checked_bycomment_count = isset($instance[$id_bycomment_count]) ? 'checked="checked"' : '';
?>
<p>
<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:', 'stallion'); ?></label> 
<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr(isset($instance['title']) ? $instance['title'] : __('Order Posts', 'stallion') ); ?>" />
</p>

<p>
<input class="checkbox" type="checkbox" <?php echo $checked_bycomment_count; ?> id="<?php echo $this->get_field_id($id_bycomment_count); ?>" name="<?php echo $this->get_field_name($id_bycomment_count); ?>" />
<label for="<?php echo $this->get_field_id($id_bycomment_count); ?>"><?php _e('Display Most Commented', 'stallion'); ?></label>
<br />
<input class="checkbox" type="checkbox" <?php echo $checked_byoldest; ?> id="<?php echo $this->get_field_id($id_byoldest); ?>" name="<?php echo $this->get_field_name($id_byoldest); ?>" />
<label for="<?php echo $this->get_field_id($id_byoldest); ?>"><?php _e('Display Old to New', 'stallion'); ?></label>
<br />
<input class="checkbox" type="checkbox" <?php echo $checked_byalphabetical; ?> id="<?php echo $this->get_field_id($id_byalphabetical); ?>" name="<?php echo $this->get_field_name($id_byalphabetical); ?>" />
<label for="<?php echo $this->get_field_id($id_byalphabetical); ?>"><?php _e('Display A to Z', 'stallion'); ?></label>
<br />
<input class="checkbox" type="checkbox" <?php echo $checked_byreversealphabetical; ?> id="<?php echo $this->get_field_id($id_byreversealphabetical); ?>" name="<?php echo $this->get_field_name($id_byreversealphabetical); ?>" />
<label for="<?php echo $this->get_field_id($id_byreversealphabetical); ?>"><?php _e('Display Z to A', 'stallion'); ?></label>
<br />
<input class="checkbox" type="checkbox" <?php echo $checked_bymodified; ?> id="<?php echo $this->get_field_id($id_bymodified); ?>" name="<?php echo $this->get_field_name($id_bymodified); ?>" />
<label for="<?php echo $this->get_field_id($id_bymodified); ?>"><?php _e('Display Recently Modified', 'stallion'); ?></label>
<br />
<input class="checkbox" type="checkbox" <?php echo $checked_byrand; ?> id="<?php echo $this->get_field_id($id_byrand); ?>" name="<?php echo $this->get_field_name($id_byrand); ?>" />
<label for="<?php echo $this->get_field_id($id_byrand); ?>"><?php _e('Display Random Order', 'stallion'); ?></label>
</p>
<?php
}

/**
 * Sanitize widget form values as they are saved.
 *
 * @see WP_Widget::update()
 *
 * @param array $new_instance Values just sent to be saved.
 * @param array $old_instance Previously saved values from database.
 *
 * @return array Upnewest safe values to be saved.
 */
public function update($new_instance, $old_instance) {
global $id_byreversealphabetical, $id_byalphabetical, $id_byoldest, $id_bymodified, $id_byrand, $id_bycomment_count;

$instance = array();
$instance['title'] = (!empty($new_instance['title']) ) ? strip_tags($new_instance['title']) : '';

$instance[$id_byreversealphabetical] = $new_instance[$id_byreversealphabetical] ? 1 : 0;
$instance[$id_byalphabetical] = $new_instance[$id_byalphabetical] ? 1 : 0;
$instance[$id_byoldest] = $new_instance[$id_byoldest] ? 1 : 0;
$instance[$id_bycomment_count] = $new_instance[$id_bycomment_count] ? 1 : 0;
$instance[$id_bymodified] = $new_instance[$id_bymodified] ? 1 : 0;
$instance[$id_byrand] = $new_instance[$id_byrand] ? 1 : 0;

return $instance;
}

}
}
?>
<?php if (function_exists('st_disp_warn2')) {
} else {
echo '<h4>This message suggests you have deleted an important file, try uploading Stallion again.</h4>';
}
?>